// Copyright (C) 2014 by Karlsruher Institut fuer Technologie (KIT), Institut fuer Mess- und Regelungstechnik
// 
// Author: Benjamin Ranft (benjamin.ranft@web.de)
// 
// This file is part of arDroneManual/Autonomous.
// 
// arDroneManual/Autonomous is free software: you can redistribute it and/or modify it under the terms of the GNU 
// General Public License as published by the Free Software Foundation, either version 3 of the License, or (at your 
// option) any later version.
// 
// arDroneManual/Autonomous is distributed in the hope that it will be useful, but WITHOUT ANY WARRANTY; without even 
// the implied warranty of MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU General Public License for 
// more details.
// 
// You should have received a copy of the GNU General Public License along with arDroneManual/Autonomous. If not, see 
// <http://www.gnu.org/licenses/>.


// wrapper for more convenient interpretation of ROS message "/ardrone/navdata"
// ============================================================================
#pragma once

#include <ardrone_autonomy/Navdata.h>

// readable values of "ardrone_autonomy::Navdata::state": The names below have just been copied from "ARDroneLib/Soft/
//                                                        Common/control_states.h" and "github.com/AutonomyLab/
//                                                        ardrone_autonomy#legacy-navigation-data".
enum NavdataState {
	navdataStateDefault  = 0, // actually after crash or carrying the drone, requires reset
	navdataStateInit     = 1, // (never saw that)
	navdataStateLanded   = 2, // landed, ready for takeoff without reset
	navdataStateFlying   = 3, // off-board flight control with at least one non-zero command
	navdataStateHovering = 4, // keep position after "GoToFix" phase while all commands still zero
	navdataStateTest     = 5, // (never saw that)
	navdataStateTakeOff  = 6, // during takeoff
	navdataStateGoToFix  = 7, // stabilize if all commands zero but not yet "Hovering"
	navdataStateLanding  = 8, // during landing
	navdataStateLooping  = 9  // during looping
} ;
